<?php

namespace App\Http\Controllers;
use App\Http\Resources\LoginResource;
use App\Models\UserApp;
use App\Models\UserAppContact;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Auth;

class AuthController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {}

    // public function register(Request $request, UserApp $user, UserAppContact $usercon)
    // {
    //     $this->validate($request, [
    //         'nip'             => 'required',
    //         'npp'             => 'required',
    //         'fullname'        => 'required',
    //         'pin'             => 'required',
    //         'gender'          => 'required',
    //         'status_participant' => 'required',
    //         'address_1'          => 'required',
    //         'address_2'          => 'required',
    //         'address_3'          => 'required',
    //         'address_detail'     => 'required',
    //         'email'              => 'required|email',
    //         'rt_no'              => 'required',
    //         'rw_no'              => 'required',
    //         'province_id'        => 'required',
    //         'city_id'            => 'required',
    //         'district_id'        => 'required',
    //         'subdistrict_id'     => 'required',
    //         'postcode'           => 'required',
    //     ]);
        
    //     $user = $user->create([
    //         'nip'             => $request->nip,
    //         'npp'             => $request->npp,
    //         'fullname'        => $request->fullname,
    //         'pin'             => Hash::make($request->pin),
    //         'api_token'       => Hash::make($request->npp),
    //         'gender'          => $request->gender,
    //         'status_participant' => $request->status_participant,
    //         'address_1'          => $request->address_1,
    //         'address_2'          => $request->address_2,
    //         'address_3'          => $request->address_3,
    //         'address_detail'     => $request->address_detail,
    //         'email'              => $request->email,
    //         'rt_no'              => $request->rt_no,
    //         'rw_no'              => $request->rw_no,
    //         'province_id'        => $request->province_id,
    //         'city_id'            => $request->city_id,
    //         'district_id'        => $request->district_id,
    //         'subdistrict_id'     => $request->subdistrict_id,
    //         'postcode'           => $request->postcode,
    //         'created_at'         => date('Y-m-d H:i:s')
    //     ]);
        
    //     $phones = array_unique($request->phone);
    //     foreach ($phones as $phone) {    
    //         $usercon = $usercon->create([
    //             'user_id'               => $user->id,    
    //             'type'                  => 'phone',    
    //             'value'                  => $phone,    
    //             'created_at'         => date('Y-m-d H:i:s')
    //         ]);
    //     }
    //     $whatsapps = array_unique($request->whatsapp);
    //     foreach ($whatsapps as $whatsapp) {    
    //         $usercon = $usercon->create([
    //             'user_id'               => $user->id,    
    //             'type'                  => 'whatsapp',    
    //             'value'                  => $whatsapp,    
    //             'created_at'         => date('Y-m-d H:i:s')
    //         ]);
    //     }
    //     $userapps = UserApp::where('id', $user->id)->first();
    //     return response()->json([
    //         'status_code' => 201,
    //         'success' => true,
    //         'message' => 'Berhasil Menambah',
    //         'data' => new LoginResource($userapps)
    //     ], 201);
    // }
    public function register(Request $request, UserApp $user, UserAppContact $usercon)
    {
        $this->validate($request, [
            'npp'             => 'required|unique:user_app',
            'fullname'        => 'required',
            'pin'             => 'required',
            'email'           => 'required|email|unique:user_app'
        ]);
  
        $user = $user->create([
            'npp'             => $request->npp,
            'fullname'        => $request->fullname,
            'pin'             => Hash::make($request->pin),
            'status'             => 'active',
            'created_at'         => date('Y-m-d H:i:s')
        ]);
        
        return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Menambah'
        ], 201);
    }

    public function login(Request $request, UserApp $user)
    {
        $this->validate($request, [
            'no_peserta'      => 'required',
            'pin'             => 'required'
        ]);
        
        try {
            $data = $user
                ->where('npp', $request->no_peserta)
                ->first();
            if ($data) {
                if(empty($data->pin)){
                    $pins = 'ikapurna'.$data->npp;
                    $pass = $data;
                    $pass->pin = Hash::make($pins);
                    $pass->save();
                }
                if (Hash::check($request->pin, $data->pin)) {
                    if($data->status == 'inactive'){
                        return response()->json(['success' => false, 'message' => 'Belum di verifikasi Admin'], 401);

                    }
                    $up_sms = UserApp::where('npp', $request->no_peserta);
                    $up_sms->update([ 
                        'api_token' =>  Hash::make(substr(str_shuffle(str_repeat("0123456789", 4)), 0, 4))
                        ]);
                    $dataa = $up_sms->first();
                    
                    $messages = [
                        'code' => 200,
                        'message' => "Berhasil",
                        'data' => new LoginResource($dataa)
                    ];
                } else {
                    $messages = [
                        'code' => 400,
                        'message' => "Pin Anda salah!"
                    ];
                }
            } else {
                $messages = [
                    'code' => 400,
                    'message' => "No Peserta dan Pin Anda salah!"
                ];
            }
        } catch (\Exception $e) {
            $messages = [
                'code' => 500,
                'message' => $e->getMessage()
            ];
        }

        return response()
            ->json($messages, $messages['code'])
            ->header('Content-Type', 'application/json');
        
    }
    
    public function guard()
    {
        return Auth::guard('api');
    }
}
