<?php

namespace App\Http\Controllers;

use App\Models\Configuration; 
use App\Models\ConfigurationContact; 
use App\Http\Resources\ConfigurationResource;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;

class ConfigurationController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    { }

    public function get($type)
    {
        $data = Configuration::where('type', $type)->first();
        
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  new ConfigurationResource($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getikapurna()
    {
        $data = Configuration::where('type', 'ikapurna')->first();
        
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  new ConfigurationResource($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sync_ikapurna(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/contacts/ikapurna",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $btn = json_decode($response);
            foreach($btn as $btn){
            $contactbtn = Configuration::where('type', 'ikapurna')->first();
            $update =  $contactbtn->update([
                    'address'                   => $btn->alamat,    
                    'email'                    => $btn->email,   
                        ]);
            //Telp
            $tel =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'phone');
            $telp = $tel->first();
            if($tel->count() > 0){
                $deltel = $telp->delete();
            }
            $notelp = explode(", ", $btn->telpon);
                foreach($notelp as $notelp){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'phone',
                                'value' => $notelp
                        ]);                              
                }
            //Mobile
            $mob =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'mobile');
            $mobile = $mob->first();
            if($mob->count() > 0){
                $delmo = $mobile->delete();
            }
            $nomob = explode(", ", $btn->hp);
                foreach($nomob as $nomob){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'mobile',
                                'value' => $nomob
                        ]);                              
                }
            //Fax
            $fa =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'fax');
            $fax = $fa->first();
            if($fa->count() > 0){
                $delmo = $fax->delete();
            }
            $nofa = explode(", ", $btn->faks);
                foreach($nofa as $nofa){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'fax',
                                'value' => $nofa
                        ]);                              
                }
            }
            $curl3 = curl_init();
            curl_setopt_array($curl3, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ikapurna/tentang_ikapurna",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response3 = curl_exec($curl3);
            $err3 = curl_error($curl3);  
            
            $au = json_decode($response3);
            foreach($au as $au){
              $aus = Configuration::where('type', 'ikapurna')->first();
              $update3 =  $aus->update([
                    'about_us' => $au->deskripsi,   
                    'maksud_tujuan' => $au->tujuan,   
                    'vision' => $au->visi,   
                    'mission' => $au->misi,   
                        ]);  
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function sync_btn(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/contacts/btn",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $btn = json_decode($response);
            foreach($btn as $btn){
            $contactbtn = Configuration::where('type', 'btn')->first();
            $update =  $contactbtn->update([
                    'address'                   => $btn->alamat,    
                    'email'                    => $btn->email,   
                        ]);
            //Telp
            $tel =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'phone');
            $telp = $tel->first();
            if($tel->count() > 0){
                $deltel = $telp->delete();
            }
            $notelp = explode(", ", $btn->telpon);
                foreach($notelp as $notelp){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'phone',
                                'value' => $notelp
                        ]);                              
                }
            //Mobile
            $mob =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'mobile');
            $mobile = $mob->first();
            if($mob->count() > 0){
                $delmo = $mobile->delete();
            }
            $nomob = explode(", ", $btn->hp);
                foreach($nomob as $nomob){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'mobile',
                                'value' => $nomob
                        ]);                              
                }
            //Fax
            $fa =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'fax');
            $fax = $fa->first();
            if($fa->count() > 0){
                $delmo = $fax->delete();
            }
            $nofa = explode(", ", $btn->faks);
                foreach($nofa as $nofa){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'fax',
                                'value' => $nofa
                        ]);                              
                }
            }
            
            
            $curl2 = curl_init();
            curl_setopt_array($curl2, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/btn/tentang_btn",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response2 = curl_exec($curl2);
            $err2 = curl_error($curl2);  
            
            $btn2 = json_decode($response2);
            
            foreach($btn2 as $btn2){
            $contactbtn = Configuration::where('type', 'btn')->first();
            $update =  $contactbtn->update([
                    'vision'                   => $btn2->visi,    
                    'mission'                    => $btn2->misi,   
                    'about_us'                    => $btn2->deskripsi,   
                        ]);
            
            }
            
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function sync_ykp(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/contacts/ykp",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $btn = json_decode($response);
            foreach($btn as $btn){
            $contactbtn = Configuration::where('type', 'ykp')->first();
            $update =  $contactbtn->update([
                    'address'                   => $btn->alamat,    
                    'email'                    => $btn->email,   
                        ]);
            //Telp
            $tel =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'phone');
            $telp = $tel->first();
            if($tel->count() > 0){
                $deltel = $telp->delete();
            }
            $notelp = explode(", ", $btn->telpon);
                foreach($notelp as $notelp){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'phone',
                                'value' => $notelp
                        ]);                              
                }
            //Mobile
            $mob =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'mobile');
            $mobile = $mob->first();
            if($mob->count() > 0){
                $delmo = $mobile->delete();
            }
            $nomob = explode(", ", $btn->hp);
                foreach($nomob as $nomob){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'mobile',
                                'value' => $nomob
                        ]);                              
                }
            //Fax
            $fa =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'fax');
            $fax = $fa->first();
            if($fa->count() > 0){
                $delmo = $fax->delete();
            }
            $nofa = explode(", ", $btn->faks);
                foreach($nofa as $nofa){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'fax',
                                'value' => $nofa
                        ]);                              
                }
            }
            
            
            //Maksud Tujuan
            $curl2 = curl_init();
            curl_setopt_array($curl2, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/maksud_tujuan",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response2 = curl_exec($curl2);
            $err2 = curl_error($curl2);  
            
            $vm = json_decode($response2);
            foreach($vm as $vm){
              $vms = Configuration::where('type', 'ykp')->first();
              $update2 =  $vms->update([
                    'maksud_tujuan' => $vm->detail,    
                        ]);  
            }
            
            
            
            
            $curl3 = curl_init();
            curl_setopt_array($curl3, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/tentang_ykp",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response3 = curl_exec($curl3);
            $err3 = curl_error($curl3);  
            
            $au = json_decode($response3);
            foreach($au as $au){
              $aus = Configuration::where('type', 'ykp')->first();
              $update3 =  $aus->update([
                    'about_us' => $au->deskripsi,    
                        ]);  
            }
            
            
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function sync_dapen(){
        
            $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/contacts/dapen",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $btn = json_decode($response);
            foreach($btn as $btn){
            $contactbtn = Configuration::where('type', 'dapen')->first();
            $update =  $contactbtn->update([
                    'address'                   => $btn->alamat,    
                    'email'                    => $btn->email,   
                        ]);
            //Telp
            $tel =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'phone');
            $telp = $tel->first();
            if($tel->count() > 0){
                $deltel = $telp->delete();
            }
            $notelp = explode(", ", $btn->telpon);
                foreach($notelp as $notelp){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'phone',
                                'value' => $notelp
                        ]);                              
                }
            //Mobile
            $mob =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'mobile');
            $mobile = $mob->first();
            if($mob->count() > 0){
                $delmo = $mobile->delete();
            }
            $nomob = explode(", ", $btn->hp);
                foreach($nomob as $nomob){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'mobile',
                                'value' => $nomob
                        ]);                              
                }
            //Fax
            $fa =  ConfigurationContact::where('conf_id', $contactbtn->id)
                                            ->where('type', 'fax');
            $fax = $fa->first();
            if($fa->count() > 0){
                $delmo = $fax->delete();
            }
            $nofa = explode(", ", $btn->faks);
                foreach($nofa as $nofa){
                    ConfigurationContact::create([
                                'conf_id' => $contactbtn->id,
                                'type' => 'fax',
                                'value' => $nofa
                        ]);                              
                }
            }
            
            //Visi Misi
            $curl2 = curl_init();
            curl_setopt_array($curl2, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/dapen/visi_misi",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response2 = curl_exec($curl2);
            $err2 = curl_error($curl2);  
            
            $vm = json_decode($response2);
            foreach($vm as $vm){
              $vms = Configuration::where('type', 'dapen')->first();
              if($vm->nama == 'Misi'){
              $update2 =  $vms->update([
                    'mission'                    => $vm->detail,    
                        ]);  
              }else{
               $update2 =  $vms->update([
                    'vision'                    => $vm->detail,    
                        ]);      
              }
            }
            
            $curl3 = curl_init();
            curl_setopt_array($curl3, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/dapen/tentang_dapen",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response3 = curl_exec($curl3);
            $err3 = curl_error($curl3);  
            
            $au = json_decode($response3);
            foreach($au as $au){
              $aus = Configuration::where('type', 'dapen')->first();
              $update3 =  $aus->update([
                    'about_us' => $au->deskripsi,    
                        ]);  
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    
     
}