<?php

namespace App\Http\Controllers;
use App\Http\Resources\ActivityResource;
use App\Models\Activity; //File Model
use App\Models\Activities; //File Model
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;

class InfoKegiatanController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
   

    public function index($id)
    {
        if($id <> 'all'){
        $data = Activity::where('type', $id)->orderby('id', 'desc')->get();
        }else{
         $data = Activity::orderby('id', 'desc')->get();   
        }
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  ActivityResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getLimit()
    {
        
         $data = Activity::orderby('id', 'desc')->skip(0)->take(4)->get();
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  ActivityResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function get($id)
    {
        $data = Activity::find($id);
        
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  new ActivityResource($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sync_info($type){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/contents/".$type,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

            foreach($act as $act){

                $cekact = Activity::where('id', $act->id)
                                    ->where('type', $type);
                if($cekact->count() == 0){
                Activity::create([
                    'id'                    => $act->id,    
                    'type'                  => $type,    
                    'title'                 => $act->title,    
                    'description'           => $act->content ?? "",    
                    'file'                  => $act->featured_image ?? "",     
                    'created_at'            => $act->created_at ?? date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cekact->update([
                    'title'                 => $act->title,    
                    'description'           => $act->content ?? "",    
                    'file'                  => $act->featured_image ?? "", 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
    
    
    //DUMMY
    public function activities($id)
    {
        if($id <> 'all'){
        $data = Activities::where('type', $id)->orderby('id', 'desc')->get();
        }else{
         $data = Activities::orderby('id', 'desc')->get();   
        }
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  ActivityResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function activities_delete($id)
    {
        $data = Activities::find($id);
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }
            $data->delete();
            
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menghapus Data'
                ];
            
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function activities_insert(Request $request)
    {
        $this->validate($request, [
            'type'            => 'required',
            'title'          => 'required',
            'description'      => 'required',
            'file'      => 'required',
        ]);
        try {
            Activities::create([    
                    'type'                  => $request->type,    
                    'title'                 => $request->title,    
                    'description'           => $request->description ?? "",    
                    'file'                  => $request->file ?? "",     
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
            
                $messages = [
                    'code' => 201,
                    'message' => 'Berhasil Menambah Data'
                ];
            
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function activities_update(Request $request, $id)
    {
        $this->validate($request, [
            'type'            => 'required',
            'title'          => 'required',
            'description'      => 'required',
            'file'      => 'required',
        ]);
        try {
            $act = Activities::find($id);
            $act->type = $request->type;
            $act->title = $request->title;
            $act->description = $request->description;
            $act->file = $request->file;
            $act->save();
            
                $messages = [
                    'code' => 201,
                    'message' => 'Berhasil Menambah Data'
                ];
            
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function get_activities($id)
    {
        $data = Activities::find($id);
        
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  new ActivityResource($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    
     
}