<?php

namespace App\Http\Controllers;

use App\Models\Plafond; //File Model
use App\Models\Outstanding; //File Model
use App\Models\TypeParam; //File Model
use App\Models\UserApp; //File Model
use App\Http\Resources\PlafondResource;
use App\Http\Resources\OutstandingResource;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;

class JamkesController extends Controller
{

    public function __construct()
    { }

    public function getplafond($npp)
    {
        $data = Plafond::where('npp', $npp)->orderby('id', 'desc')->skip(0)->take(5)->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  PlafondResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getoutstand($npp)
    {
        $data = Outstanding::where('npp', $npp)->orderby('id', 'desc')->get()->unique('type');
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  OutstandingResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sync_outstanding($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/mutasi?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $data = json_decode($response);

            foreach($data->List as $data){
                $cek = Outstanding::where('code', $data->id)
                                        ->where('npp', $data->npp);
                      
                // if($data->plafond_type == '1'){
                //     $type = 'rawat_inap';
                // }elseif($data->plafond_type == '2'){
                //     $type = 'gawat_darurat';
                // }elseif($data->plafond_type == '3'){
                //     $type = 'rehabilitasi_medis';
                // }elseif($data->plafond_type == '4'){
                //     $type = 'penunjang_diagnostic';
                // }elseif($data->plafond_type == '5'){
                //     $type = 'penyakit_khusus';
                // }else{
                //     $type = '';
                // }  
                $type = $data->plafond_type;
                $pla = Plafond::where('type', $type)
                                        ->where('npp', $data->npp)->first();  
                $saldo = $pla->amount - $data->amount;
                if($cek->count() == 0){
                Outstanding::create([
                    'code'                    => $data->id,    
                    'npp'                   => $data->npp,      
                    'type'                  => $type,    
                    'maksimum'              => $pla->amount,    
                    'mutasi'                => $data->amount, 
                    'position_date'         => $data->posisi_data, 
                    'saldo'                 => $saldo,  
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cek->update([
                    'type'                  => $type,    
                    'maksimum'              => $pla->amount,    
                    'mutasi'                => $data->amount,  
                    'position_date'         => $data->posisi_data, 
                    'saldo'                 => $saldo, 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    
    public function sync_plafond($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/plafond?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $data = json_decode($response);

            foreach($data->List as $data){
                $cek = Plafond::where('code', $data->id)
                                        ->where('npp', $data->npp);
                                        
                // if($data->plafond_type == '1'){
                //     $type = 'rawat_inap';
                // }elseif($data->plafond_type == '2'){
                //     $type = 'gawat_darurat';
                // }elseif($data->plafond_type == '3'){
                //     $type = 'rehabilitasi_medis';
                // }elseif($data->plafond_type == '4'){
                //     $type = 'penunjang_diagnostic';
                // }elseif($data->plafond_type == '5'){
                //     $type = 'penyakit_khusus';
                // }else{
                //     $type = '';
                // }  
                $type = $data->plafond_type;
                if($cek->count() == 0){
                Plafond::create([
                    'code'                    => $data->id,    
                    'npp'                   => $data->npp,      
                    'type'                  => $type,     
                    'amount'                => $data->amount,    
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cek->update([
                    'type'                  => $type,    
                    'type_class'            => $data->type_class ?? "vip",    
                    'amount'                => $data->amount, 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    // public function sync_plafond($page){
        
    //   $curl = curl_init();
    //         curl_setopt_array($curl, array(
    //           CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/plafond?page=".$page,
    //           CURLOPT_RETURNTRANSFER => true,
    //           CURLOPT_ENCODING => "",
    //           CURLOPT_MAXREDIRS => 10,
    //           CURLOPT_TIMEOUT => 30,
    //           CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    //           CURLOPT_CUSTOMREQUEST => "GET",
    //           CURLOPT_HTTPHEADER => array(
    //             "content-type: application/json"
    //           ),
    //         ));
            
    //         $response = curl_exec($curl);
    //         $err = curl_error($curl);  
            
    //         $data = json_decode($response);

    //         foreach($data->List as $data){
    //             $cek = Plafond::where('id', $data->id)
    //                                     ->where('npp', $data->npp);
                                        
    //             if($data->plafond_type == '1'){
    //                 $type = 'rawat_inap';
    //             }elseif($data->plafond_type == '2'){
    //                 $type = 'gawat_darurat';
    //             }elseif($data->plafond_type == '3'){
    //                 $type = 'rehabilitasi_medis';
    //             }elseif($data->plafond_type == '4'){
    //                 $type = 'penunjang_diagnostic';
    //             }elseif($data->plafond_type == '5'){
    //                 $type = 'penyakit_khusus';
    //             }else{
    //                 $type = '';
    //             }                          
    //             if($cek->count() == 0){
    //             Plafond::create([
    //                 'id'                    => $data->id,    
    //                 'npp'                   => $data->npp,      
    //                 'type'                  => $type,     
    //                 'amount'                => $data->amount,    
    //                 'created_at'            => date("Y-m-d H:i:s")
    //             ]);
    //             }else{
    //               $update =  $cek->update([
    //                 'type'                  => $type,    
    //                 'type_class'            => $data->type_class ?? "vip",    
    //                 'amount'                => $data->amount, 
    //                     ]); 
    //             }
    //         }
    //         return response()->json([
    //         'status_code' => 201,
    //         'success' => true,
    //         'message' => 'Berhasil Sync',
    //     ], 201);    
            
    // }
    public function sync_type_kelas($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/kelas_perawatan?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $data = json_decode($response);

            foreach($data->List as $data){
                $cek = Plafond::where('npp', $data->npp);
                $cek2 = UserApp::where('npp', $data->npp);            
                  if(($data->kelas == 'I') or ($data->kelas == 'I ')){
                      $kelas = "i";
                  }elseif(($data->kelas == 'II') or ($data->kelas == 'II ')){
                      $kelas = "ii";
                  }elseif(($data->kelas == 'III') or ($data->kelas == 'III ')){
                      $kelas = "iii";
                  }elseif(($data->kelas == 'VIP') or ($data->kelas == 'VIP ')){
                      $kelas = "vip";
                  }               
                if($cek->count() > 0){
                $update =  $cek->update([   
                    'type_class'            => $kelas,    
                        ]); 
                }
                if($cek2->count() > 0){
                $update2 =  $cek2->update([   
                    'type_class'            => $kelas,    
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function get_type_p(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/param",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $data = json_decode($response);
            foreach($data as $data){
                $cek = TypeParam::where('id', $data->id);
                                        
                                         
                if($cek->count() == 0){
                TypeParam::create([
                    'id'                    => $data->id,    
                    'title'                   => $data->name,     
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cek->update([
                    'title'                  => $data->name,    
                        ]); 
                }
            }
            
            return response()->json([
            'status_code' => 200,
            'success' => true,
            'message' => 'Berhasil Sync Data',
        ], 200);
            
            
    }
    // public function reimburse(Request $request){
    //     $url = "https://sipurna.com/aplikasi/api/ykp/reimbuse";

    //     $client = new Client();
        
    //     $response = $client->request('POST', $url, [
    //         'multipart' => [
    //             [
    //                 'name'     => 'npp',
    //                 'contents' => $request->npp
    //             ],
    //             [
    //                 'name'     => 'nama',
    //                 'contents' => $request->nama
    //             ],
    //             [
    //                 'name'     => 'hp',
    //                 'contents' => $request->hp
    //             ],
    //             [
    //                 'name'     => 'email',
    //                 'contents' => $request->email
    //             ],
    //             [
    //                 'name'     => 'tanggal',
    //                 'contents' => $request->tanggal
    //             ],
    //             [
    //                 'name'     => 'nominal',
    //                 'contents' => $request->nominal
    //             ],
    //             [
    //                 'name'     => 'keterangan',
    //                 'contents' => $request->keterangan
    //             ],
    //             [
    //                 'name'     => 'keterangan',
    //                 'contents' => $request->keterangan
    //             ],
    //             [
    //                 'name'     => 'attachment1',
    //                 'contents' => fopen($request->attachment1, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment2',
    //                 'contents' => fopen($request->attachment2, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment3',
    //                 'contents' => fopen($request->attachment3, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment4',
    //                 'contents' => fopen($request->attachment4, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment5',
    //                 'contents' => fopen($request->attachment5, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment6',
    //                 'contents' => fopen($request->attachment6, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment7',
    //                 'contents' => fopen($request->attachment7, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment8',
    //                 'contents' => fopen($request->attachment8, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment9',
    //                 'contents' => fopen($request->attachment9, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //             [
    //                 'name'     => 'attachment10',
    //                 'contents' => fopen($request->attachment10, 'r'),
    //                 'headers'  => ['Content-Type' => 'image/jpeg']
    //             ],
    //         ],
      
    //     ]);
    //     return $response->getBody();
    // }
     
}