<?php

namespace App\Http\Controllers;
use App\Models\ManagementBtn;
use App\Models\RegionalComittee;
use App\Models\CenterComittee;
use App\Models\Slider;
use App\Mail\Reimburse;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use Intervention\Image\ImageManagerStatic as Image;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;

class ManagementController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function get_keu_btn(){
       
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "http://sipurna.com/aplikasi/api/btn/lap_keu_btn",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

           
            return $act;
            
            
    }
   public function getslider()
    {
        $data = Slider::orderBy('urutan', 'asc')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getcity()
    {
        $data = DB::table('app_rs_provider')
                        ->select('address')->groupby('address')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getcity2()
    {
        $data = DB::table('app_rs_faskes')
                        ->select('city_id')->groupby('city_id')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getbtn($type)
    {
        $data = ManagementBtn::where('type',$type)->orderby('code', 'asc')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getreg(Request $request)
    {
        $data = RegionalComittee::where('description', $request->city)->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getcityreg()
    {
        
        $data = RegionalComittee::selectRaw('description AS city')
                                    ->groupby('description')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getcen($type)
    {
        $data = CenterComittee::where('type', $type)->orderby('urutan', 'asc')->get();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sync_mbtn($type){
        if($type == 'direksi_dapen' || $type == 'dewan_pengawas_dapen'){
            $jen = "dapen";
        }else{
            $jen = "btn";
        }
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/btn/".$type,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

            foreach($act as $act){

                $cekact = ManagementBtn::where('code', $act->id)
                                        ->where('type', $type);
                
                if($cekact->count() == 0){
                
                ManagementBtn::create([
                    'code'                  => $act->id,
                    'type'                  => $type,    
                    'name'                  => $act->name,    
                    'position'              => $act->position,    
                    'file'                  => $act->img_path, 
                    'educational_background'=> $act->riwayat, 
                    'work_experience'       => $act->karir, 
                    'description'           => $act->desc, 
                    'created_at'            => date("Y-m-d H:i:s"),  
                ]);
                }else{
                  $update =  $cekact->update([
                    'type'                  => $type,    
                    'name'                  => $act->name,    
                    'position'              => $act->position,    
                    'educational_background'=> $act->riwayat, 
                    'work_experience'       => $act->karir, 
                    'description'           => $act->desc, 
                    'file'                  => $act->img_path,   
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
    public function sync_regional(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ikapurna/pengurus_daerah",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

            foreach($act as $act){

                $cekact = RegionalComittee::where('id', $act->id);
                if($cekact->count() == 0){
                RegionalComittee::create([
                    'id'                    => $act->id,    
                    'code'                  => $act->code,    
                    'name'                  => $act->nama,    
                    'position'              => $act->jabatan,    
                    'description'           => $act->description, 
                    'address'               => $act->alamat, 
                    'phone'                 => $act->no_hp, 
                    'file'                  => $act->img_path, 
                    'created_at'            => date("Y-m-d H:i:s"),  
                ]);
                }else{
                  $update =  $cekact->update([
                    'code'                  => $act->code,    
                    'name'                  => $act->nama,    
                    'position'              => $act->jabatan,    
                    'description'           => $act->description, 
                    'address'               => $act->alamat, 
                    'phone'                 => $act->no_hp, 
                    'file'                  => $act->img_path, 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
    public function sync_center($type){
        if($type == 'ikapurna'){
          $link = "ikapurna/pengurus_pusat";
        }elseif($type == 'direksi_dapen'){
          $link = "dapen/direksi_dapen";
        }elseif($type == 'dewan_pengawas_dapen'){
          $link = "dapen/dewan_pengawas_dapen";
        }elseif($type == 'pembina_ykp'){
          $link = "ykp/pembina_ykp";
        }elseif($type == 'pengawas_ykp'){
          $link = "ykp/pengawas_ykp";
        }elseif($type == 'badan_pengawas_ikapurna'){
          $link = "ikapurna/badan_pengawas";
        }else{
           $link = "ykp/pengurus_ykp"; 
        }
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/".$link,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

            foreach($act as $act){

                $cekact = CenterComittee::where('code', $act->id)
                                            ->where('type', $type);
                if($cekact->count() == 0){
                CenterComittee::create([   
                    'code'                  => $act->id, 
                    'name'                  => $act->nama,   
                    'type'                  => $type,   
                    'position'              => $act->jabatan,    
                    'address'               => $act->alamat ?? "", 
                    'phone'                 => $act->no_hp ?? "", 
                    'file'                  => $act->img_path, 
                    'urutan'                => $act->urutan ?? 0, 
                    'created_at'            => date("Y-m-d H:i:s"),  
                ]);
                }else{
                  $update =  $cekact->update([    
                    'name'                  => $act->nama,    
                    'position'              => $act->jabatan,    
                    'address'               => $act->alamat, 
                    'phone'                 => $act->no_hp, 
                    'file'                  => $act->img_path, 
                    'urutan'                => $act->urutan ?? 0, 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
    
     public function get_fdapen(){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/dapen/finansial_dapen",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $act = json_decode($response);

            
            return response()->json([
            'status_code' => 200,
            'success' => true,
            'message' => 'Berhasil Menampilkan Data',
            'data' => $act,
        ], 200);
            
            
    }
    public function reimburse(Request $request){
        $validation = Validator::make($request->all(), [
            'npp'               => 'required',
            'nama'              => 'required',
            'hp'                => 'required',
            'tanggal'           => 'required',
            'email'           => 'required',
            'nominal'           => 'required',
            'keterangan'        => 'required',
            'attachment_1'      => 'required',
            'attachment_2'      => 'nullable',
            'attachment_3'      => 'nullable',
            'attachment_4'      => 'nullable',
            'attachment_5'      => 'nullable',
            'attachment_6'      => 'nullable',
            'attachment_7'      => 'nullable',
            'attachment_8'      => 'nullable',
            'attachment_9'      => 'nullable',
            'attachment_10'     => 'nullable',
        ]);

        $nama = $request->nama;
        $email = $request->email;
        // return $request->all();
        $target_url = "https://sipurna.com/aplikasi/api/ykp/reimburse";           
        $attachment_1 = $request->file('attachment_1');   
        $cattachment_1 = new \CURLFile(realpath($attachment_1));
        
        if($request->hasFile('attachment_2')){
        $attachment_2 = $request->file('attachment_2');   
        $cattachment_2 = new \CURLFile(realpath($attachment_2));
        }else{$cattachment_2= null;}
        
        if($request->hasFile('attachment_3')){
        $attachment_3 = $request->file('attachment_3');   
        $cattachment_3 = new \CURLFile(realpath($attachment_3));
        }else{$cattachment_3= null;}
        
        if($request->hasFile('attachment_4')){
        $attachment_4 = $request->file('attachment_4');   
        $cattachment_4 = new \CURLFile(realpath($attachment_4));
        }else{$cattachment_4= null;}
        
        if($request->hasFile('attachment_5')){
        $attachment_5 = $request->file('attachment_5');   
        $cattachment_5 = new \CURLFile(realpath($attachment_5));
        }else{$cattachment_5= null;}
        
        if($request->hasFile('attachment_6')){
        $attachment_6 = $request->file('attachment_6');   
        $cattachment_6 = new \CURLFile(realpath($attachment_6));
        }else{$cattachment_6= null;}
        
        if($request->hasFile('attachment_7')){
        $attachment_7 = $request->file('attachment_7');   
        $cattachment_7 = new \CURLFile(realpath($attachment_7));
        }else{$cattachment_7= null;}
        
        if($request->hasFile('attachment_8')){
        $attachment_8 = $request->file('attachment_8');   
        $cattachment_8 = new \CURLFile(realpath($attachment_8));
        }else{$cattachment_8= null;}
        
        if($request->hasFile('attachment_9')){
        $attachment_9 = $request->file('attachment_9');   
        $cattachment_9 = new \CURLFile(realpath($attachment_9));
        }else{$cattachment_9= null;}
        
        if($request->hasFile('attachment_10')){
        $attachment_10 = $request->file('attachment_10');   
        $cattachment_10 = new \CURLFile(realpath($attachment_10));
        }else{$cattachment_10= null;}
        
        $post = array (
                        'npp' => $request->npp,
                        'nama' => $request->nama,
                        'hp' => $request->hp,
                        'tanggal' => $request->tanggal,
                        'email' => $request->email,
                        'nominal' => $request->nominal,
                        'keterangan' => $request->keterangan,
                        'attachment_1' => $cattachment_1,
                        'attachment_2' => $cattachment_2,
                        'attachment_3' => $cattachment_3,
                        'attachment_4' => $cattachment_4,
                        'attachment_5' => $cattachment_5,
                        'attachment_6' => $cattachment_6,
                        'attachment_7' => $cattachment_7,
                        'attachment_8' => $cattachment_8,
                        'attachment_9' => $cattachment_9,
                        'attachment_10' => $cattachment_10
                      );    
    
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $target_url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");   
        curl_setopt($ch, CURLOPT_HTTPHEADER,array('Content-Type: multipart/form-data'));
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);   
        curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);  
        curl_setopt($ch, CURLOPT_TIMEOUT, 100);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    
        $result = curl_exec ($ch);
    
        if ($result === FALSE) {
            return response()->json([
            'status_code' => 500,
            'success' => false,
            'message' => "Error sending" . $fname .  " " . curl_error($ch)
            ], 500);
        } 
        
        curl_close ($ch);
        //Send Mail
        
        $res = json_decode($result, true);
        
        
        $files = array();
        $no = 1;
        foreach($res['attach'] as $attach){
        $files[] = $attach['0'];
        $no++;
        }
        $data = $post;
        Mail::send('email.reimburse', $data, function($message) use($data, $files) {
        
        $message->to('ykpbtn@yahoo.com', 'YKP Bank BTN')->subject('Form Reimburse');
        // $message->to('ferdiansyah071@gmail.com', 'YKP Bank BTN')->subject('Form Reimburse');
        // $message->to('viandry8002@gmail.com', 'YKP Bank BTN')->subject('Form Reimburse');
        $message->from($data['email'], $data['nama']);
        foreach($files as $file){
            $url = str_replace('https://sipurna.com/', '', $file);
            $message->attach(base_path(env('PATH_WEB').$url));
        }

        });
       

        return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'success',
        ], 201);
            
    }
    public function jaminan(Request $request){
        $validation = Validator::make($request->all(), [
            'npp'               => 'required',
            'nama'              => 'required',
            'hp'                => 'required',
            'tanggal'           => 'required',
            'email'             => 'required',
            'pasien'            => 'required',
            'rs'                => 'required',
            'attachment_1'      => 'required',
            'attachment_2'      => 'nullable',
            'attachment_3'      => 'nullable',
            'attachment_4'      => 'nullable',
            'attachment_5'      => 'nullable',
            'attachment_6'      => 'nullable',
            'attachment_7'      => 'nullable',
            'attachment_8'      => 'nullable',
            'attachment_9'      => 'nullable',
            'attachment_10'     => 'nullable',
        ]);
        // return $request->all();
        $target_url = "https://sipurna.com/aplikasi/api/ykp/jaminan";           
        $attachment_1 = $request->file('attachment_1');   
        $cattachment_1 = new \CURLFile(realpath($attachment_1));
        
        if($request->hasFile('attachment_2')){
        $attachment_2 = $request->file('attachment_2');   
        $cattachment_2 = new \CURLFile(realpath($attachment_2));
        }else{$cattachment_2= null;}
        
        if($request->hasFile('attachment_3')){
        $attachment_3 = $request->file('attachment_3');   
        $cattachment_3 = new \CURLFile(realpath($attachment_3));
        }else{$cattachment_3= null;}
        
        if($request->hasFile('attachment_4')){
        $attachment_4 = $request->file('attachment_4');   
        $cattachment_4 = new \CURLFile(realpath($attachment_4));
        }else{$cattachment_4= null;}
        
        if($request->hasFile('attachment_5')){
        $attachment_5 = $request->file('attachment_5');   
        $cattachment_5 = new \CURLFile(realpath($attachment_5));
        }else{$cattachment_5= null;}
        
        if($request->hasFile('attachment_6')){
        $attachment_6 = $request->file('attachment_6');   
        $cattachment_6 = new \CURLFile(realpath($attachment_6));
        }else{$cattachment_6= null;}
        
        if($request->hasFile('attachment_7')){
        $attachment_7 = $request->file('attachment_7');   
        $cattachment_7 = new \CURLFile(realpath($attachment_7));
        }else{$cattachment_7= null;}
        
        if($request->hasFile('attachment_8')){
        $attachment_8 = $request->file('attachment_8');   
        $cattachment_8 = new \CURLFile(realpath($attachment_8));
        }else{$cattachment_8= null;}
        
        if($request->hasFile('attachment_9')){
        $attachment_9 = $request->file('attachment_9');   
        $cattachment_9 = new \CURLFile(realpath($attachment_9));
        }else{$cattachment_9= null;}
        
        if($request->hasFile('attachment_10')){
        $attachment_10 = $request->file('attachment_10');   
        $cattachment_10 = new \CURLFile(realpath($attachment_10));
        }else{$cattachment_10= null;}
        
        $post = array (
                        'npp' => $request->npp,
                        'nama' => $request->nama,
                        'hp' => $request->hp,
                        'tanggal' => $request->tanggal,
                        'email' => $request->email,
                        'pasien' => $request->pasien,
                        'rs' => $request->rs,
                        'keterangan' => $request->keterangan,
                        'attachment_1' => $cattachment_1,
                        'attachment_2' => $cattachment_2,
                        'attachment_3' => $cattachment_3,
                        'attachment_4' => $cattachment_4,
                        'attachment_5' => $cattachment_5,
                        'attachment_6' => $cattachment_6,
                        'attachment_7' => $cattachment_7,
                        'attachment_8' => $cattachment_8,
                        'attachment_9' => $cattachment_9,
                        'attachment_10' => $cattachment_10
                      );    
    
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $target_url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");   
        curl_setopt($ch, CURLOPT_HTTPHEADER,array('Content-Type: multipart/form-data'));
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);   
        curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);  
        curl_setopt($ch, CURLOPT_TIMEOUT, 100);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    
        $result = curl_exec ($ch);
    
        if ($result === FALSE) {
            return response()->json([
            'status_code' => 500,
            'success' => false,
            'message' => "Error sending" . $fname .  " " . curl_error($ch)
        ], 500);
        } 

        $res = json_decode($result, true);
        
        
        $files = array();
        $no = 1;
        foreach($res['attach'] as $attach){
        $files[] = $attach['0'];
        $no++;
        }
        $data = $post; 
        Mail::send('email.jaminan', $data, function($message) use ($data, $files) {
        
        $message->to('ykpbtn@yahoo.com', 'YKP Bank BTN')->subject('Form Jaminan RS');
        $message->from($data['email'],$data['nama']);
        foreach($files as $file){
            $url = str_replace('https://sipurna.com/', '', $file);
            $message->attach(base_path(env('PATH_WEB').$url));
        }
        });
        curl_close ($ch);
        return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'success',
            'data' => null
        ], 201);
            
    }
     public function syncpus(){
            $header = array(
                  'Accept: application/json',
                  'Content-Type: multipart/form-data'
                );
            /*Login*/
            $postlogin = array (
                        'f_username' => 'epak_pustakawan',
                        'f_password' => 'r0komY4nM4s2021'
                      );   
		    $ch1 = curl_init();
                curl_setopt($ch1, CURLOPT_URL, 'https://api-ropeg.kemkes.go.id/apirokom/login');
                curl_setopt($ch1, CURLOPT_POST, 1);
                curl_setopt($ch1, CURLOPT_HEADER, 0);
                curl_setopt($ch1, CURLOPT_HTTPHEADER, $header);
                curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, false);
                curl_setopt($ch1, CURLOPT_POSTFIELDS, $postlogin);
            
                $resultlogin = curl_exec ($ch1);
                $errlogin = curl_error($ch1);  
                $actlogin = json_decode($resultlogin, true);
                $token =  $actlogin['token']; 
            
            /*Data Pusatakawan*/
            $postpus = array (
                        'f_token' => $token
                      );   
		    $ch2 = curl_init();
                curl_setopt($ch2, CURLOPT_URL, 'https://api-ropeg.kemkes.go.id/apirokom/list_pegawai');
                curl_setopt($ch2, CURLOPT_POST, 1);
                curl_setopt($ch2, CURLOPT_HEADER, 0);
                curl_setopt($ch2, CURLOPT_HTTPHEADER, $header);
                curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch2, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch2, CURLOPT_SSL_VERIFYHOST, false);
                curl_setopt($ch2, CURLOPT_POSTFIELDS, $postpus);
                $resultpus = curl_exec ($ch2);
                $errpus = curl_error($ch2);  
                $actpus = json_decode($resultpus, true);
                return $actpus;
     }
     public function jdih(){
        // return "skajs";
		
		$curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://www.dokumjdih.jatimprov.go.id/pemprov/api_dokum/get_prokum?token=f55e2735458c88409dca44e16f4878a6&kabko=23&period=2021&jenis=perda",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_SSL_VERIFYPEER => FALSE,
              CURLOPT_SSL_VERIFYHOST => FALSE,
              CURLOPT_CONNECTTIMEOUT => FALSE,
              CURLOPT_FOLLOWLOCATION => TRUE,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_IPRESOLVE => CURL_IPRESOLVE_V4,
            //   CURLOPT_VERBOSE=>true,
            //   CURLOPT_STDERR=>STDOUT,
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            if(curl_exec($curl) === false) {
            echo 'Curl error: ' . curl_error($curl);
            } else {
                return json_decode($response, true);
            }
            curl_close($curl);
    // 		$ch = curl_init();
    //         curl_setopt($ch, CURLOPT_URL, "https://www.dokumjdih.jatimprov.go.id/pemprov/api_dokum/get_prokum?token=f55e2735458c88409dca44e16f4878a6&kabko=23&period=2021&jenis=perda");
    //         curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    //             "Content-Type: application/json"
    //         ));
    //         curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
    //         curl_setopt($ch, CURLOPT_HEADER, FALSE);
    //         curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    //         curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    //         curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
    //         curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    //         curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0); 
    //         curl_setopt($ch, CURLOPT_TIMEOUT, 900);
            
    //         $response = curl_exec($ch);
    //         $err = curl_error($ch);
    //         curl_close($ch);
    //         $res = json_decode($response, true);
    //         var_dump($response);

     }
     
}