<?php

namespace App\Http\Controllers;

use App\Models\RSYkp; 
use App\Models\RSBpjs; 
use App\Http\Resources\NotificationResource;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Auth;

class RsController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    { }
    public function index()
    {
        $data = RSYkp::orderBy('id', 'desc')->paginate(10);
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sindex(Request $request)
    {
        $data = RSYkp::orderBy('id', 'desc');
                    if($request->src <> ''){
                    $data = $data->where('title', 'like', '%' . $request->src. '%');
                    }
                    if($request->kota <> ''){
                    $data = $data->where('address', $request->kota);
                    }
                    $data = $data->paginate(10); 
        // if(($request->src <> '') and ($request->kota == '')){
        // $data = RSYkp::where('title', 'like', '%' . $request->src . '%')
        //             ->orderBy('id', 'desc')->paginate(10);
        // }elseif(($request->src == '') and ($request->kota <> '')){
        //  $data = RSYkp::where('address', $request->kota)
        //             ->orderBy('id', 'desc')->paginate(10);   
        // }elseif(($request->src <> '') and ($request->kota <> '')){
        //  $data = RSYkp::where('title', 'like', '%' . $request->src. '%')
        //             ->where('address', $request->kota)
        //             ->orderBy('id', 'desc')->paginate(10);   
        // }
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sindex_loc(Request $request)
    {
        $this->validate($request, [
            'latitude_user'          => 'required',
            'longitude_user'         => 'required',
        ]);
        $lat = $request->latitude_user;
        $long = $request->longitude_user;
                    $data = RSYkp::orderBy('id', 'desc');
                    if($request->src <> ''){
                    $data = $data->where('title', 'like', '%' . $request->src. '%');
                    }
                    if($request->kota <> ''){
                    $data = $data->where('address', $request->kota);
                    }

                    //PAGING
                    $count = $data->count();

                    $limit = 10;
                    $totalpage = ceil($count/$limit);
                    $page = $request->page ?? 1;
                    if($page == 1){
                        $urlprev = null;
                        $skip = 0;
                        $next = $page+1;
                        $urlnext = env('APP_URL').'api/rsykp/search-location?page='.$next;
                    }else{
                        
                        $next = $page+1;
                        $prev = $page-1;
                        $skip = (($page - 1) * $limit) ;
                        $urlprev = env('APP_URL').'api/rsykp/search-location?page='.$prev;
                        if($totalpage == $page){
                        $urlnext = null;
                        }else{
                        $urlnext = env('APP_URL').'api/rsykp/search-location?page='.$next;
                        }
                    }
                    $data = $data->get()->map(function ($item) use ($lat,$long) {
                        if($item->latitude <> '' and $item->longitude <> ''){
                            $distance = round(RSYkp::distance($lat, $long, $item->latitude, $item->longitude, 'K'));
                        }else{
                            $distance = 99999999999999999999;
                        }
                        $item['distance'] = $distance;
                        return $item;
                    });
                    $loc = $data->sortBy(function($items){
                        return $items->distance;
                    });
                    $locs = $loc->skip($skip)->take($limit);
                    $paging = [
                        'total_data' => $count,
                        'total_page' => $totalpage,
                        'total_per_page' => $limit,
                        'url_next' => $urlnext,
                        'url_previous' => $urlprev,
                    ];
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>   array_values($locs->toArray()),
                    'detail_pagination' =>  $paging
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function indexbpjs()
    {
        $data = RSBpjs::orderBy('id', 'desc')->paginate(10);
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sindexbpjs(Request $request)
    {
        
        if(($request->src <> '') and ($request->kota == '')){
        $data = RSBpjs::where('title', 'like', '%' . $request->src . '%')
                    ->orderBy('id', 'desc')->paginate(10);
        }elseif(($request->src == '') and ($request->kota <> '')){
         $data = RSBpjs::where('city_id', $request->kota)
                    ->orderBy('id', 'desc')->paginate(10);   
        }elseif(($request->src <> '') and ($request->kota <> '')){
         $data = RSBpjs::where('title', 'like', '%' . $request->src. '%')
                    ->where('city_id', $request->kota)
                    ->orderBy('id', 'desc')->paginate(10);   
        }
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function sindexbpjs_loc(Request $request)
    {
        
        $this->validate($request, [
            'latitude_user'          => 'required',
            'longitude_user'         => 'required',
        ]);
        $lat = $request->latitude_user;
        $long = $request->longitude_user;
         $data = RSBpjs::orderBy('id', 'desc');
         if($request->src <> ''){
         $data = $data->where('title', 'like', '%' . $request->src. '%');
         }
         if($request->kota <> ''){
         $data = $data->where('city_id', $request->kota);
         }
         //PAGING
         $count = $data->count();

         $limit = 20;
         $totalpage = ceil($count/$limit);
         $page = $request->page ?? 1;
         if($page == 1){
             $urlprev = null;
             $skip = 0;
             $next = $page+1;
             $urlnext = env('APP_URL').'api/rsbpjs/search-location?page='.$next;
         }else{
             
             $next = $page+1;
             $prev = $page-1;
             $skip = (($page - 1) * $limit) ;
             $urlprev = env('APP_URL').'api/rsbpjs/search-location?page='.$prev;
             if($totalpage == $page){
             $urlnext = null;
             }else{
             $urlnext = env('APP_URL').'api/rsbpjs/search-location?page='.$next;
             }
         }
         $data = $data->get()->map(function ($item) use ($lat,$long) {
            if($item->latitude <> '' and $item->longitude <> ''){
                $distance = round(RSBpjs::distance($lat, $long, $item->latitude, $item->longitude, 'K'));
            }else{
                $distance = 99999999999999999999;
            }
            $item['distance'] = $distance;
            return $item;
        });
        $loc = $data->sortBy(function($items){
            return $items->distance;
        });
        $locs = $loc->skip($skip)->take($limit);
        $paging = [
            'total_data' => $count,
            'total_page' => $totalpage,
            'total_per_page' => $limit,
            'url_next' => $urlnext,
            'url_previous' => $urlprev,
        ];
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  array_values($locs->toArray()),
                    'detail_pagination' =>  $paging
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
   
    public function sindexall_loc(Request $request)
    {
        
        $this->validate($request, [
            'latitude_user'          => 'required',
            'longitude_user'         => 'required',
        ]);
        
        $lat = $request->latitude_user;
        $long = $request->longitude_user;
         $a = RSBpjs::select('id', 'longitude', 'latitude')
                ->addSelect(DB::raw('"rs_bpjs" as type_rs'));
         if($request->src <> ''){
         $a = $a->where('title', 'like', '%' . $request->src. '%');
         }
         if($request->kota <> ''){
         $a = $a->where('city_id', $request->kota);
         }
         $b = RSYkp::select('id', 'longitude', 'latitude')
         ->addSelect(DB::raw('"rs_ykp" as type_rs'));
         if($request->src <> ''){
         $b = $b->where('title', 'like', '%' . $request->src. '%');
         }
         if($request->kota <> ''){
         $b = $b->where('address', $request->kota);
         }

         //PAGING
         $count = 100;

         $limit = 20;
         $totalpage = ceil($count/$limit);
         $page = $request->page ?? 1;
         if($page == 1){
            $urlprev = null;
            $skip = 0;
            $next = $page+1;
            $urlnext = env('APP_URL').'api/rs/search-location?page='.$next;
         }else{
            
            $next = $page+1;
            $prev = $page-1;
            $skip = (($page - 1) * $limit) ;
            $urlprev = env('APP_URL').'api/rs/search-location?page='.$prev;
            if($totalpage == $page){
            $urlnext = null;
            }else{
            $urlnext = env('APP_URL').'api/rs/search-location?page='.$next;
            }
         }

         $data  = $b->union($a)
                    ->get()->map(function ($item) use ($lat,$long) {
                        if($item->latitude <> '' and $item->longitude <> ''){
                            if($item->type_rs == 'rs_ykp'){
                            $distances = round(RSYkp::distance($lat, $long, $item->latitude, $item->longitude, 'K'));
                            }else{
                            $distances = round(RSBpjs::distance($lat, $long, $item->latitude, $item->longitude, 'K'));
                            }
                            if($distances > 0){
                                $distance = $distances;
                            }else{
                                $distance = 99999999999999999999;
                            }
                        }else{
                            $distance = 99999999999999999999;
                        }
                        if($item->type_rs == 'rs_ykp'){
                            $detail = RSYkp::where('id', $item->id)->get()->map(function ($item2) {
                                $lat = str_replace(',','',$item2->latitude);
                                $lon = str_replace(',','',$item2->longitude);
                                if ((strpos($lat, '.') == false) || (strpos($lon, '.') == false)) {
                                    $lats = null;
                                    $lons = null;
                                }else{
                                    $lats = $lat;
                                    $lons = $lon;
                                }
                               
                                $item2['latitude'] = $lats;
                                $item2['longitude'] = $lons;
                                return $item2;
                            });
                        }else{
                            $detail = RSBpjs::where('id', $item->id)->get()->map(function ($item3) {
                                $lat = str_replace(',','',$item3->latitude);
                                if (strpos($lat, '.') !== false) {
                                    $lats = $lat;
                                }else{
                                    $lats = null;
                                }
                                $lon = str_replace(',','',$item3->longitude);
                                if (strpos($lon, '.') !== false) {
                                    $lons = $lon;
                                }else{
                                    $lons = null;
                                }
                                $item3['latitude'] = $lats;
                                $item3['longitude'] = $lons;
                                return $item3;
                            });;
                        }
                        
                        $item['distance'] = $distance;
                        $item['detail'] = $detail;
                        return $item;
                    })->sortBy('distance');
                    // $links = $data->appends(['order' => 'distance'])->links();
        $loc = $data->sortBy(function($items){
            return $items->distance;
        });
        
        $locs = $data->skip($skip)->take($limit);
        $paging = [
            'total_data' => $count,
            'total_page' => $totalpage,
            'total_per_page' => $limit,
            'url_next' => $urlnext,
            'url_previous' => $urlprev,
        ];
       


        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  array_slice(array_values($locs->toArray()), 0, 100),
                    'detail_pagination' => $paging
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    
    public function sync_rsykp($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/rs?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $rs = json_decode($response);

            foreach($rs->List as $rs){

                $cekrs = RSYkp::where('id', $rs->id_rs);
                if($cekrs->count() == 0){
                RSYkp::create([
                    'id'                    => $rs->id_rs,    
                    'title'                 => $rs->nama_rs,    
                    'area'                  => $rs->daerah,    
                    'address'               => $rs->alamat_rs,    
                    'phone'                 => $rs->telepon_rs,    
                    'fax'                   => $rs->no_faks,    
                    'description'           => $rs->keterangan,    
                    'latitude'              => $rs->latitude ?? "",    
                    'longitude'             => $rs->longitude ?? "",   
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cekrs->update([
                    'title'                 => $rs->nama_rs,     
                    'area'                  => $rs->daerah,    
                    'address'               => $rs->alamat_rs,    
                    'phone'                 => $rs->telepon_rs,    
                    'fax'                   => $rs->no_faks,    
                    'description'           => $rs->keterangan,    
                    'latitude'              => $rs->latitude ?? "",    
                    'longitude'             => $rs->longitude ?? "", 
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
    
    public function sync_rsbpjs($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/faskes?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $rs = json_decode($response);

            foreach($rs->List as $rs){

                $cekrs = RSBpjs::where('code', $rs->kode_faskes);
                if($cekrs->count() == 0){
                RSBpjs::create([
                    'code'                  => $rs->kode_faskes,    
                    'title'                 => $rs->nama_faskes,    
                    'type_id'               => $rs->tipe_faskes,    
                    'address'               => $rs->alamat,    
                    'province_id'           => $rs->propinsi,    
                    'city_id'               => $rs->kab_kota,    
                    'district_id'           => $rs->kecamatan,  
                    'subdistrict_id'       => $rs->desa ?? "",  
                    'latitude'              => $rs->latitude ?? "",    
                    'longitude'             => $rs->longitude ?? "",  
                    'rt_no'                 => $rs->RT,  
                    'rw_no'                 => $rs->RW,  
                    'postcode'              => $rs->kodepos,  
                    'phone'                 => $rs->nomor_telpon,  
                    'schedule_open'         => $rs->jadwal_praktek,  
                    'status'                => 'active',  
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cekrs->update([
                    'title'                 => $rs->nama_faskes,    
                    'type_id'               => $rs->tipe_faskes,    
                    'address'               => $rs->alamat,    
                    'province_id'           => $rs->propinsi,    
                    'city_id'               => $rs->kab_kota,    
                    'district_id'           => $rs->kecamatan,  
                    'subdistrict_id'       => $rs->desa ?? "",  
                    'latitude'              => $rs->latitude ?? "",    
                    'longitude'             => $rs->longitude ?? "",  
                    'rt_no'                 => $rs->RT,  
                    'rw_no'                 => $rs->RW,  
                    'postcode'              => $rs->kodepos,  
                    'phone'                 => $rs->nomor_telpon,  
                    'schedule_open'         => $rs->jadwal_praktek,  
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);
            
            
    }
     
}