<?php

namespace App\Http\Controllers;
use App\Http\Resources\UserResource;
use App\Http\Resources\UserParentResource;
use App\Models\UserApp;
use App\Models\UserAppContact;
use App\Models\UserAppParent;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Intervention\Image\ImageManagerStatic as Image;;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Carbon\Carbon;
use Auth;
use App\Models\Counting;

class UserAppController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        
    }

   

    public function index(){
        $data = UserApp::all();
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  $data
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function getparent($npp){
        $data = UserAppParent::where('npp', $npp)->get();
        
        
        try {
            if($data->isEmpty()){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                //$data->date_place = date('d-m-Y', strtotime($data->date_place));
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  UserParentResource::collection($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function get($id){
        $data = UserApp::find($id);
        
        try {
            if(!$data){
                $messages = [
                    'code' => 400,
                    'message' => 'Tidak Ada Data'
                ];
            }else{
                $messages = [
                    'code' => 200,
                    'message' => 'Berhasil Menampilkan Data',
                    'data' =>  new UserResource($data)
                ];
            }
        }catch (\Exception $e) {
                    $messages = [
                        'code' => 500,
                        'message' => $e->getMessage()
                    ];
        }
                return response()
                    ->json($messages, $messages['code'])
                    ->header('Content-Type', 'application/json');
    }
    public function update(Request $request, $id){
        $validation = Validator::make($request->all(), [
            'nip'             => 'required',
            'fullname'        => 'required',
            'gender'          => 'required',
            'status_participant' => 'required',
            'address_1'          => 'required',
            'address_2'          => 'required',
            'address_3'          => 'required',
            'address_detail'     => 'required',
            'email'              => 'required|email',
            'rt_no'              => 'required',
            'rw_no'              => 'required',
            'province_id'        => 'required',
            'city_id'            => 'required',
            'district_id'        => 'required',
            'subdistrict_id'     => 'required',
            'postcode'           => 'required',
        ]);
        if ($validation->fails()) {
            return response()->json(
                [   'status'  =>'error',
                    'code'   => '302',
                    'message' => $validation->messages(),
                ], 302);
        }
        
        $user=DB::table('user_app')
                        ->where('id',$id);
        $user->update([
            'nip'             => $request->nip,
            'fullname'        => $request->fullname,
            'gender'          => $request->gender,
            'status_participant' => $request->status_participant,
            'address_1'          => $request->address_1,
            'address_2'          => $request->address_2,
            'address_3'          => $request->address_3,
            'address_detail'     => $request->address_detail,
            'email'              => $request->email,
            'rt_no'              => $request->rt_no,
            'rw_no'              => $request->rw_no,
            'province_id'        => $request->province_id,
            'city_id'            => $request->city_id,
            'district_id'        => $request->district_id,
            'subdistrict_id'     => $request->subdistrict_id,
            'postcode'           => $request->postcode
            ]);
            return response()->json(
                [   'status'  =>'success',
                    'code'   => '201',
                    'message' => 'Berhasil Mengubah',
                ], 201);
    }
    public function updatepassword(Request $request){
        
              $this->validate($request, [
            'npp'             => 'required',
            'pin'             => 'required',
        ]);
         
                $cekuser = UserApp::where('npp', $request->npp);
                if($cekuser->count() > 0){
                 $update =  $cekuser->update([
                    'pin'  => Hash::make($request->pin),    
                    
                        ]); 
                }else{
                  return response()->json([
                    'status_code' => 400,
                    'success' => false,
                    'message' => 'Tidak Ada Data',
                ], 400);   
                  
                }
            
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Update',
        ], 201);   
    }
    public function getPage(){
       
    }
    
    public function sync_user($page=""){
        $curl = curl_init();
        // for($i=1; $i <= $this->getPage(); $i++){
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://sipurna.com/aplikasi/api/pensiunan/pensiunan?page=".$page,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                    "content-type: application/json"
                ),
            ));
                
            $response = curl_exec($curl);
            $err = curl_error($curl);  
                
            $lists = json_decode($response);

            foreach($lists->pensiunanList as $users){

                // echo $users->npp.'</br>';
                if($users->gender == 1){
                    $gender = "male";
                }else{
                    $gender = "female";
                }
                if($users->akses_korlap == 'TRUE'){
                    $akses = "true";
                }else{
                    $akses = "false";
                }
                $cekuser = UserApp::where('npp', $users->npp);
                if($cekuser->count() == 0){
                    UserApp::create([
                        'npp'                   => $users->npp,    
                        'fullname'              => $users->fullname,    
                        'pin'                   => Hash::make('ikapurna'.$users->npp),    
                        'nip'                   => $users->nip ?? 0,    
                        'gender'                => $gender,    
                        'address_1'             => $users->address,    
                        'birth_place'           => $users->birth_place,    
                        'birth_date'            => $users->birth_date ?? NULL,    
                        'address_2'             => $users->address2 ?? "",    
                        'address_3'             => $users->address3 ?? "",    
                        'address_detail'        => $users->address_detail ?? "",    
                        'email'                 => $users->email,    
                        'rt_no'                 => $users->rt,    
                        'rw_no'                 => $users->rw,    
                        'province_id'           => $users->province,    
                        'city_id'               => $users->regency,    
                        'district_id'           => $users->district,    
                        'subdistrict_id'        => $users->village,    
                        'postcode'              => $users->postal_code,    
                        'status_participant'    => $users->pension_status,
                        'created_at'            => date("Y-m-d H:i:s"),
                        'sts_ybs'               => $users->marital_status,
                        'bpjs_number'           => $users->bpjs_number,
                        'is_korlap'             => $akses,
                    ]);
                    
                }else{
                      $update =  $cekuser->update([
                        'npp'                   => $users->npp,    
                        'fullname'              => $users->fullname,      
                        'nip'                   => $users->nip ?? 0,    
                        'gender'                => $gender,  
                        'birth_place'           => $users->birth_place,    
                        'birth_date'            => $users->birth_date ?? NULL,    
                        'address_1'             => $users->address,    
                        'address_2'             => $users->address2 ?? "",    
                        'address_3'             => $users->address3 ?? "",    
                        'address_detail'        => $users->address_detail ?? "",    
                        'email'                 => $users->email,    
                        'rt_no'                 => $users->rt,    
                        'rw_no'                 => $users->rw,    
                        'province_id'           => $users->province,    
                        'city_id'               => $users->regency,    
                        'district_id'           => $users->district,    
                        'subdistrict_id'        => $users->village,    
                        'postcode'              => $users->postal_code,    
                        'status_participant'    => $users->pension_status,
                        'sts_ybs'               => $users->marital_status,
                        'bpjs_number'           => $users->bpjs_number,
                        'is_korlap'             => $akses,
                            ]); 
                }
   
                $cekuserc = UserAppContact::where('user_id', $users->npp)->where('type', 'phone');
                if($cekuserc->count() == 0){
                            UserAppContact::create([
                            'user_id'               => $users->npp,    
                            'type'                  => 'phone',    
                            'value'                 => $users->phone, 
                            'created_at'            =>date("Y-m-d H:i:s"), 
                            ]);
                }else{
                          $updatec  =  $cekuserc->update([   
                            'type'                  => 'phone',    
                            'value'                 => $users->phone, 
                            ]);
                }
            }
        // }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function sync_user_parent($page){
        
       $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => "https://sipurna.com/aplikasi/api/ykp/keluarga?page=".$page,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET",
              CURLOPT_HTTPHEADER => array(
                "content-type: application/json"
              ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);  
            
            $users = json_decode($response);

            foreach($users->keluargaList as $users){
                $cekuser = UserAppParent::where('npp', $users->npp)
                                        ->where('id', $users->id);
                if($cekuser->count() == 0){
                UserAppParent::create([
                    'id'                    => $users->id,    
                    'npp'                   => $users->npp,      
                    'fullname'              => $users->nama,    
                    'birth_place'           => $users->birth_place ?? "",    
                    'date_place'            => date('Y-m-d', strtotime($users->ttl)),    
                    'type'                  => $users->status,    
                    'created_at'            => date("Y-m-d H:i:s")
                ]);
                }else{
                  $update =  $cekuser->update([
                    'fullname'              => $users->nama,    
                    'birth_place'           => $users->birth_place ?? "",    
                    'date_place'            => date('Y-m-d', strtotime($users->ttl)),    
                    'type'                  => $users->status,  
                        ]); 
                }
            }
            return response()->json([
            'status_code' => 201,
            'success' => true,
            'message' => 'Berhasil Sync',
        ], 201);    
            
    }
    public function notif()
    {
        $content = "test oyy";
        $users = '8,';
        $namespace = 'App\Http\Controllers';
        $controller = app()->make($namespace.'\NotificationController');
        return $controller->callAction('sendMessage',[$content, base64_encode($users)]);
        return response()->json([
            'status_code' => 200,
            'success' => true,
            'message' => $users,
        ], 200);
        
    }

}
