<?php

namespace App\Http\Resources;
use App\Models\UserAppContact;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Facades\DB;

class UserResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array
     */
    public function toArray($request)
    { 
        if($this->sts_ybs == "2"){
             $sp =  "Tidak Kawin";
        }elseif($this->sts_ybs == "3"){
            $sp = "Duda";
        }elseif($this->sts_ybs == "1"){
            $sp =  "Kawin";
        }elseif($this->sts_ybs == "4"){
            $sp =  "Janda";
        }else{
            $sp =  "-";
        }
        if($this->gender == 'male'){
            $gender = "Laki-Laki";
        }else{
            $gender = "Perempuan";
        }
        // if($this->province_id <> ''){
        // $p = DB::table('provinces')
        //                 ->where('id',$this->province_id)->first();
        // $prov = $p->name;
        // }else{
        // $prov = "-";    
        // } 
        if($this->file <> ''){
            $file = "http://sipurna.com/aplikasi/assets/admin/upload/img/".$this->file;
        }else{
            $file = null;
        }
        return [
            'id'                   => $this->id,
            'fullname'             => $this->fullname,
            'nip'                  => $this->nip,
            'npp'                  => $this->npp,
            'gender'               => $gender,
            'birth_place'          => $this->birth_place,
            'birth_date'           => date('d-m-Y', strtotime($this->birth_date)),
            'file'                 => $file,
            'status_participant'   => $this->status_participant,
            'address_1'            => $this->address_1,
            'address_2'            => $this->address_2,
            'address_3'            => $this->address_3,
            'address_detail'       => $this->address_detail,
            'address_detail'       => $this->address_detail,
            'rt_no'                => $this->rt_no,
            'rw_no'                => $this->rw_no,
            'province_id'          => $this->province_id,
            'city_id'              => $this->city_id,
            'district_id'          => $this->district_id,
            'subdistrict_id'       => $this->subdistrict_id,
            'postcode'             => $this->postcode,
            'sts_ybs'              => $sp,
            'sum_anak'             =>$this->sum_anak,
            'is_korlap'             =>$this->is_korlap,
            'phone'                => UserAppContact::where([
                                    'user_id' => $this->npp,
                                    'type' => 'phone'
                                    ])->get(),
            'whatsapp'             => UserAppContact::where([
                                        'user_id' => $this->npp,
                                        'type' => 'whatsapp'
                                        ])->get(),
        ];
    }
}
