<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class RSBpjs extends Model 
{

    protected $table = 'app_rs_faskes';
    public $timestamps = false;
    protected $fillable = [
        'type_id', 
        'code',
        'title',
        'province_id',
        'city_id',
        'district_id',
        'subdistrict_id',
        'address',
        'rt_no',
        'postcode',
        'phone',
        'schedule_open',
        'status',
        'created_at',
        'rw_no'

    ];
    
    public static function distance($lat1, $lon1, $lat2, $lon2, $unit)
    {
        
            if (($lat1 == $lat2) && ($lon1 == $lon2)) {
            return 0;
            }elseif ($lon2 == 0) {
            return null;
            }else{
            $lat2 = (float) $lat2;
            $lon2 = (float) $lon2;
            $theta = (float) $lon1 - $lon2;
            $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
            $dist = acos($dist);
            $dist = rad2deg($dist);
            $miles = $dist * 60 * 1.1515;
            $unit = strtoupper($unit);
        
            if ($unit == "K") {
                return ($miles * 1.609344);
            } else if ($unit == "N") {
                return ($miles * 0.8684);
            } else {
                return $miles;
            }
            }
    }
}
