<?php
/** @var \Laravel\Lumen\Routing\Router $router */
date_default_timezone_set("Asia/Jakarta");
/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/
$router->get('cron-counting/{page}', 'UserAppController@cronCounting');
$router->group(['prefix' => 'api'], function () use ($router) {
  
  $router->post('register', 'AuthController@register');
  $router->post('login', 'AuthController@login');
  $router->get('jdih', 'ManagementController@jdih');
  //SYNC
    $router->post('reimburse', 'ManagementController@reimburse');
    $router->post('reimbucrse', 'ManagementController@reimbucrse');
    $router->post('jaminan-rs', 'ManagementController@jaminan');
    $router->get('sync-user/{page}', 'UserAppController@sync_user');
    $router->get('sync-user', 'UserAppController@sync_user');
    $router->get('sync-userparent/{page}', 'UserAppController@sync_user_parent');
    $router->get('sync-rsykp/{page}', 'RsController@sync_rsykp');
    $router->get('sync-rsbpjs/{page}', 'RsController@sync_rsbpjs');
    $router->get('sync-info/{type}', 'InfoKegiatanController@sync_info');
    $router->get('test-notif/{content}', 'NotificationController@sendMessage');
    $router->get('sync-contact/btn', 'ConfigurationController@sync_btn');
    $router->get('sync-contact/ykp', 'ConfigurationController@sync_ykp');
    $router->get('sync-contact/dapen', 'ConfigurationController@sync_dapen');
    $router->get('sync-contact/ikapurna', 'ConfigurationController@sync_ikapurna');
    $router->get('sync-mbtn/{type}', 'ManagementController@sync_mbtn');
    $router->get('sync-pdaerah', 'ManagementController@sync_regional');
    $router->get('sync-ppusat/{type}', 'ManagementController@sync_center');
    $router->get('sync-plafond/{page}', 'JamkesController@sync_plafond');
    $router->get('sync-pus', 'ManagementController@syncpus');
    
    $router->get('sync-typep/', 'JamkesController@get_type_p');
    
    $router->get('type_class/sync-plafond/{page}', 'JamkesController@sync_type_kelas');
    $router->get('sync-outstand/{page}', 'JamkesController@sync_outstanding');
    
    
    $router->get('cs-ikapurna', 'ConfigurationController@getikapurna');
      $router->post('/user/change-password', 'UserAppController@updatepassword');
      $router->group(['middleware' => 'auth:api'], function () use ($router) {
        $router->get('/user', 'UserAppController@index');
        $router->get('/city', 'ManagementController@getcity');
        $router->get('/city2', 'ManagementController@getcity2');
        $router->get('/user/parent/{npp}', 'UserAppController@getparent');
        $router->get('/user/{id}', 'UserAppController@get');
        $router->put('/user/edit/{id}', 'UserAppController@update');
        $router->post('/user/image', 'UserAppController@updateimage');
        
        $router->get('/faq', 'FaqController@index');
        
        $router->get('/rsykp', 'RsController@index');
        $router->get('/rsbpjs', 'RsController@indexbpjs');
        $router->post('/rsykp/search', 'RsController@sindex');
        $router->post('/rsbpjs/search', 'RsController@sindexbpjs');
        $router->post('/rsykp/search-location', 'RsController@sindex_loc');
        $router->post('/rsbpjs/search-location', 'RsController@sindexbpjs_loc');
        $router->post('/rs/search-location', 'RsController@sindexall_loc');
        
        $router->get('/configuration/{type}', 'ConfigurationController@get');
        
        $router->get('/notification/{id}', 'NotificationController@index');
        $router->get('/notification/detail/{id}', 'NotificationController@get');
        $router->post('/notification/read/', 'NotificationController@read');
        $router->delete('/notification/{notif_read_id}', 'NotificationController@del_notif');
        $router->delete('/notification/all/{user_id}', 'NotificationController@del_notif_all');
        
        $router->get('/activity/{id}', 'InfoKegiatanController@index');
        $router->get('/activity/detail/{id}', 'InfoKegiatanController@get');
        $router->get('/activity_limit/', 'InfoKegiatanController@getLimit');

         $router->get('/mbtn/{type}', 'ManagementController@getbtn');
         $router->post('/pdaerah', 'ManagementController@getreg');
         $router->get('/pdaerah/city', 'ManagementController@getcityreg');
         $router->get('/ppusat/{type}', 'ManagementController@getcen');
         $router->get('/slider', 'ManagementController@getslider');
         $router->get('/finansial-dapen', 'ManagementController@get_fdapen');
         $router->get('/plafond/{npp}', 'JamkesController@getplafond');
         $router->get('/outstand/{npp}', 'JamkesController@getoutstand');
         
         $router->get('/lap-keu-btn', 'ManagementController@get_keu_btn');
         
         //DUMMY
         $router->get('/activities/{id}', 'InfoKegiatanController@activities');
         $router->delete('/activities-delete/{id}', 'InfoKegiatanController@activities_delete');
         $router->post('/activities', 'InfoKegiatanController@activities_insert');
         
        //  Ajukan Jaminan RS
        $router->post('/rs-guarantee', 'HospitalGuaranteeController@create');
        $router->get('/rs-guarantee/{id}', 'HospitalGuaranteeController@index');
        $router->get('/rs-guarantee/detail/{id}', 'HospitalGuaranteeController@detail');
        $router->post('/rs-guarantee/confirm', 'HospitalGuaranteeController@confirm');
         
  });
  $router->get('/activities-detail/{id}', 'InfoKegiatanController@get_activities');
  $router->post('/activities', 'InfoKegiatanController@activities_insert');
  $router->put('/activities/{id}', 'InfoKegiatanController@activities_update');
  
});
